

(define (domain gold-miner-typed)
(:requirements :typing )
(:types loc)

(:predicates 	
		(robot-at ?x - loc)
		(bomb-at ?x - loc )
		(laser-at ?x - loc)
		(soft-rock-at ?x - loc)
		(hard-rock-at ?x - loc)
		(gold-at ?x - loc)
		(arm-empty)
		(holds-bomb)
                (holds-laser)
		(holds-gold)
		(clear ?x - loc)		
		(connected ?x - loc ?y - loc)
)
(:action move
  :parameters (?x - loc ?y - loc)
  :precondition (and (robot-at ?x) (connected ?x ?y) (clear ?y))
  :effect (and (robot-at ?y) (not (robot-at ?x)) )
)

(:action pickup-laser
  :parameters (?x - loc)
  :precondition (and (robot-at ?x) (laser-at ?x) (arm-empty))
  :effect (and (not (arm-empty)) (holds-laser) (not (laser-at ?x)) )
)
(:action pickup-bomb
  :parameters (?x - loc)
  :precondition (and (robot-at ?x) (bomb-at ?x) (arm-empty))
  :effect (and (not (arm-empty)) (holds-bomb) )
)

(:action putdown-laser
  :parameters (?x - loc)
  :precondition (and (robot-at ?x) (holds-laser))
  :effect (and (arm-empty) (not (holds-laser)) (laser-at ?x) )
)
(:action detonate-bomb 
  :parameters (?x - loc ?y - loc)
  :precondition (and (robot-at ?x) (holds-bomb) 
                     (connected ?x ?y) (soft-rock-at ?y))
  :effect (and (not (holds-bomb)) (arm-empty) (clear ?y) (not (soft-rock-at ?y)) )
)

(:action fire-laser
  :parameters (?x - loc ?y - loc)
  :precondition (and (robot-at ?x) (holds-laser) 
                     (connected ?x ?y)) 
  :effect (and (clear ?y) (not (soft-rock-at ?y)) (not (gold-at ?y))
               (not (hard-rock-at ?y)) )
)        
					   
(:action pick-gold
  :parameters (?x - loc)
  :precondition (and (robot-at ?x) (arm-empty) (gold-at ?x))
  :effect (and (not (arm-empty)) (holds-gold) )
)
)
